Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90	(revision 10251)
@@ -28,7 +28,4 @@
 !> @endcode
 !>    
-!> @note 
-!>    you could find a template of the namelist in templates directory.
-!>
 !>    merge_bathy.nam comprise 8 namelists:
 !>       - logger namelist (namlog)
@@ -48,5 +45,5 @@
 !>       - cn_logfile   : logger filename
 !>       - cn_verbosity : verbosity ('trace','debug','info',
-!>  'warning','error','fatal','none')
+!>  'warning','error','fatal')
 !>       - in_maxerror  : maximum number of error allowed
 !>
@@ -65,10 +62,10 @@
 !>    * _variable namelist (namvar)_:
 !>       - cn_varinfo : list of variable and extra information about request(s) 
-!>       to be used (separated by ',').<br/>
+!>       to be used.<br/>
 !>          each elements of *cn_varinfo* is a string character.<br/>
 !>          it is composed of the variable name follow by ':', 
 !>          then request(s) to be used on this variable.<br/> 
 !>          request could be:
-!>             - int = interpolation method
+!>             - interpolation method
 !> 
 !>                requests must be separated by ';'.<br/>
@@ -77,5 +74,5 @@
 !>          informations about available method could be find in 
 !>          @ref interp modules.<br/>
-!>          Example: 'bathymetry: int=cubic'
+!>          Example: 'bathymetry: cubic'
 !>          @note 
 !>             If you do not specify a method which is required, 
@@ -98,9 +95,9 @@
 !>          segments are separated by '|'.<br/>
 !>          each segments of the boundary is composed of:
-!>             - indice of velocity (orthogonal to boundary .ie. 
-!>                for north boundary, J-indice). 
-!>             - indice of segment start (I-indice for north boundary) 
-!>             - indice of segment end   (I-indice for north boundary)<br/>
-!>                indices must be separated by ':' .<br/>
+!>             - orthogonal indice (.ie. for north boundary,
+!>             J-indice where boundary are). 
+!>             - first indice of boundary (I-indice for north boundary) 
+!>             - last  indice of boundary (I-indice for north boundary)<br/>
+!>                indices must be separated by ',' .<br/>
 !>             - optionally, boundary size could be added between '(' and ')' 
 !>             in the first segment defined.
@@ -109,7 +106,6 @@
 !>
 !>          Examples:
-!>             - cn_north='index1,first1:last1(width)'
-!>             - cn_north='index1(width),first1:last1|index2,first2:last2'
-!>
+!>             - cn_north='index1,first1,last1(width)'
+!>             - cn_north='index1(width),first1,last1|index2,first2,last2'
 !>       - cn_south : south boundary indices on fine grid<br/>
 !>       - cn_east  : east  boundary indices on fine grid<br/>
@@ -125,7 +121,4 @@
 !> @date Sepember, 2014 
 !> - add header for user
-!> @date July, 2015 
-!> - extrapolate all land points
-!> - add attributes with boundary string character (as in namelist)
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -160,5 +153,4 @@
    CHARACTER(LEN=lc)                                  :: cl_namelist
    CHARACTER(LEN=lc)                                  :: cl_date
-   CHARACTER(LEN=lc)                                  :: cl_tmp
 
    INTEGER(i4)                                        :: il_narg
@@ -170,5 +162,4 @@
    INTEGER(i4)                                        :: il_jmin0
    INTEGER(i4)                                        :: il_jmax0
-   INTEGER(i4)                                        :: il_shift
    INTEGER(i4)      , DIMENSION(ip_maxdim)            :: il_rho
    INTEGER(i4)      , DIMENSION(2,2)                  :: il_ind
@@ -240,6 +231,5 @@
    NAMELIST /namlog/ &  !< logger namelist
    &  cn_logfile,    &  !< log file
-   &  cn_verbosity,  &  !< log verbosity
-   &  in_maxerror       !< logger maximum error
+   &  cn_verbosity      !< log verbosity
 
    NAMELIST /namcfg/ &  !< config namelist
@@ -308,5 +298,5 @@
       READ( il_fileid, NML = namlog )
       ! define log file
-      CALL logger_open(TRIM(cn_logfile),TRIM(cn_verbosity),in_maxerror)
+      CALL logger_open(TRIM(cn_logfile),TRIM(cn_verbosity), in_maxerror)
       CALL logger_header()
 
@@ -520,78 +510,4 @@
    ENDIF
 
-
-   IF( tl_bdy(jp_north)%l_use )THEN
-      ! add shift on north boundary
-      ! boundary compute on T point but express on U or V point
-      il_shift=1
-
-      cl_tmp=TRIM(fct_str(tl_bdy(jp_north)%t_seg(1)%i_index-il_shift))//','//&
-         &   TRIM(fct_str(tl_bdy(jp_north)%t_seg(1)%i_first))//':'//&
-         &   TRIM(fct_str(tl_bdy(jp_north)%t_seg(1)%i_last))//&
-         &   '('//TRIM(fct_str(tl_bdy(jp_north)%t_seg(1)%i_width))//')'
-      DO ji=2,tl_bdy(jp_north)%i_nseg
-         cl_tmp=TRIM(cl_tmp)//'|'//&
-            &   TRIM(fct_str(tl_bdy(jp_north)%t_seg(ji)%i_index-il_shift))//','//&
-            &   TRIM(fct_str(tl_bdy(jp_north)%t_seg(ji)%i_first))//':'//&
-            &   TRIM(fct_str(tl_bdy(jp_north)%t_seg(ji)%i_last))
-      ENDDO
-      tl_att=att_init("bdy_north",TRIM(cl_tmp))
-      CALL file_add_att(tl_fileout, tl_att)
-   ENDIF
-
-   IF( tl_bdy(jp_south)%l_use )THEN
-      
-      cl_tmp=TRIM(fct_str(tl_bdy(jp_south)%t_seg(1)%i_index))//','//&
-         &   TRIM(fct_str(tl_bdy(jp_south)%t_seg(1)%i_first))//':'//&
-         &   TRIM(fct_str(tl_bdy(jp_south)%t_seg(1)%i_last))//&
-         &   '('//TRIM(fct_str(tl_bdy(jp_south)%t_seg(1)%i_width))//')'
-      DO ji=2,tl_bdy(jp_south)%i_nseg
-         cl_tmp=TRIM(cl_tmp)//'|'//&
-            &   TRIM(fct_str(tl_bdy(jp_south)%t_seg(ji)%i_index))//','//&
-            &   TRIM(fct_str(tl_bdy(jp_south)%t_seg(ji)%i_first))//':'//&
-            &   TRIM(fct_str(tl_bdy(jp_south)%t_seg(ji)%i_last))
-      ENDDO
-
-      tl_att=att_init("bdy_south",TRIM(cl_tmp))
-      CALL file_add_att(tl_fileout, tl_att)
-   ENDIF
-
-   IF( tl_bdy(jp_east)%l_use )THEN
-      ! add shift on east boundary
-      ! boundary compute on T point but express on U or V point
-      il_shift=1
-
-      cl_tmp=TRIM(fct_str(tl_bdy(jp_east)%t_seg(1)%i_index-il_shift))//','//&
-         &   TRIM(fct_str(tl_bdy(jp_east)%t_seg(1)%i_first))//':'//&
-         &   TRIM(fct_str(tl_bdy(jp_east)%t_seg(1)%i_last))//&
-         &   '('//TRIM(fct_str(tl_bdy(jp_east)%t_seg(1)%i_width))//')'
-      DO ji=2,tl_bdy(jp_east)%i_nseg
-         cl_tmp=TRIM(cl_tmp)//'|'//&
-            &   TRIM(fct_str(tl_bdy(jp_east)%t_seg(ji)%i_index-il_shift))//','//&
-            &   TRIM(fct_str(tl_bdy(jp_east)%t_seg(ji)%i_first))//':'//&
-            &   TRIM(fct_str(tl_bdy(jp_east)%t_seg(ji)%i_last))
-      ENDDO
-
-      tl_att=att_init("bdy_east",TRIM(cl_tmp))
-      CALL file_add_att(tl_fileout, tl_att)
-   ENDIF
-
-   IF( tl_bdy(jp_west)%l_use )THEN
-
-      cl_tmp=TRIM(fct_str(tl_bdy(jp_west)%t_seg(1)%i_index))//','//&
-         &   TRIM(fct_str(tl_bdy(jp_west)%t_seg(1)%i_first))//':'//&
-         &   TRIM(fct_str(tl_bdy(jp_west)%t_seg(1)%i_last))//&
-         &   '('//TRIM(fct_str(tl_bdy(jp_west)%t_seg(1)%i_width))//')'
-      DO ji=2,tl_bdy(jp_west)%i_nseg
-         cl_tmp=TRIM(cl_tmp)//'|'//&
-            &   TRIM(fct_str(tl_bdy(jp_west)%t_seg(ji)%i_index))//','//&
-            &   TRIM(fct_str(tl_bdy(jp_west)%t_seg(ji)%i_first))//':'//&
-            &   TRIM(fct_str(tl_bdy(jp_west)%t_seg(ji)%i_last))
-      ENDDO
-
-      tl_att=att_init("bdy_west",TRIM(cl_tmp))
-      CALL file_add_att(tl_fileout, tl_att)
-   ENDIF
-
    ! create file
    CALL iom_create(tl_fileout)
@@ -609,5 +525,4 @@
    CALL mpp_clean(tl_bathy0)
    DEALLOCATE(dl_weight)
-   CALL boundary_clean(tl_bdy(:))
 
    ! close log file
@@ -993,5 +908,7 @@
 
       ! extrapolate variable
-      CALL extrap_fill_value( td_var )
+      CALL extrap_fill_value( td_var, id_offset=id_offset(:,:), &
+      &                               id_rho=id_rho(:),         &
+      &                               id_iext=il_iext, id_jext=il_jext )
 
       ! interpolate Bathymetry
Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 10251)
@@ -165,11 +165,13 @@
 !>    to get processors to be used:<br/>
 !> @code
-!>    CALL mpp_get_use( td_mpp, id_imin, id_imax, & 
-!>    &                         id_jmin, id_jmax )
+!>    CALL mpp_get_use( td_mpp, id_imin, id_imax, id_idim, & 
+!>    &                         id_jmin, id_jmax, id_jdim )
 !> @endcode
 !>       - id_imin 
 !>       - id_imax 
+!>       - id_idim 
 !>       - id_jmin 
 !>       - id_jmax 
+!>       - id_jdim 
 !>
 !>    to get sub domains which form global domain contour:<br/>
@@ -350,5 +352,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date November, 2014
    !>    - use function instead of overload assignment operator 
@@ -377,5 +379,4 @@
       ! copy mpp variable
       mpp__copy_unit%c_name     = TRIM(td_mpp%c_name)
-      mpp__copy_unit%i_id       = td_mpp%i_id
       mpp__copy_unit%i_niproc   = td_mpp%i_niproc
       mpp__copy_unit%i_njproc   = td_mpp%i_njproc
@@ -424,5 +425,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date November, 2014
    !>    - use function instead of overload assignment operator 
@@ -453,5 +454,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - Nov, 2013- Initial Version
    !
    !> @param[in] td_mpp mpp structure
@@ -494,5 +495,5 @@
       ! print dimension
       IF(  td_mpp%i_ndim /= 0 )THEN
-         WRITE(*,'(/a)') " MPP dimension"
+         WRITE(*,'(/a)') " File dimension"
          DO ji=1,ip_maxdim
             IF( td_mpp%t_dim(ji)%l_use )THEN
@@ -697,5 +698,5 @@
       CALL dim_clean(tl_dim)
 
-      IF( (       PRESENT(id_niproc)  .AND. (.NOT. PRESENT(id_njproc))) .OR. &
+      IF( (       PRESENT(id_niproc)  .AND. (.NOT. PRESENT(id_niproc))) .OR. &
           ((.NOT. PRESENT(id_niproc)) .AND.        PRESENT(id_njproc) ) )THEN
           CALL logger_warn( "MPP INIT: number of processors following I and J "//&
@@ -911,5 +912,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_file   file strcuture
@@ -1027,29 +1028,29 @@
             ! create some attributes for domain decomposition (use with dimg file)
             tl_att=att_init( "DOMAIN_number_total", mpp__init_file%i_nproc )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_I_position_first", mpp__init_file%t_proc(:)%i_impp )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_J_position_first", mpp__init_file%t_proc(:)%i_jmpp )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_I_position_last", mpp__init_file%t_proc(:)%i_lci )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_J_position_last", mpp__init_file%t_proc(:)%i_lcj )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_I_halo_size_start", mpp__init_file%t_proc(:)%i_ldi )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_J_halo_size_start", mpp__init_file%t_proc(:)%i_ldj )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_I_halo_size_end", mpp__init_file%t_proc(:)%i_lei )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
 
             tl_att=att_init( "DOMAIN_J_halo_size_end", mpp__init_file%t_proc(:)%i_lej )
-            CALL mpp_move_att(mpp__init_file, tl_att)
+            CALL mpp_add_att(mpp__init_file, tl_att)
             
             ! clean
@@ -1121,4 +1122,5 @@
       CALL file_clean(tl_file)
 
+      CALL logger_debug("MPP INIT READ: fin init_read ")
    END FUNCTION mpp__init_file
    !-------------------------------------------------------------------
@@ -1129,6 +1131,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date July, 2015 - add only use dimension in MPP structure
+   !> - November, 2013- Initial Version
    !>
    !> @param[in] td_file   file strcuture
@@ -1162,6 +1163,6 @@
          IF( td_file%i_id == 0 )THEN
             CALL logger_info(" id "//TRIM(fct_str(td_file%i_id))) 
-            CALL logger_error("MPP INIT READ: netcdf file "//&
-               &  TRIM(td_file%c_name)//" not opened")
+            CALL logger_error("MPP INIT READ: netcdf file "//TRIM(td_file%c_name)//&
+            &  " not opened")
          ELSE
 
@@ -1190,14 +1191,9 @@
                CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
             ENDIF
-
-            IF( td_file%t_dim(3)%l_use )THEN
-               tl_dim=dim_init( td_file%t_dim(3)%c_name, td_file%t_dim(3)%i_len)
-               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
-            ENDIF
-
-            IF( td_file%t_dim(4)%l_use )THEN
-               tl_dim=dim_init( td_file%t_dim(4)%c_name, td_file%t_dim(4)%i_len)
-               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
-            ENDIF
+            tl_dim=dim_init( td_file%t_dim(3)%c_name, td_file%t_dim(3)%i_len)
+            CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+
+            tl_dim=dim_init( td_file%t_dim(4)%c_name, td_file%t_dim(4)%i_len)
+            CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
 
             ! initialise file/processor
@@ -1316,5 +1312,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_file   file strcuture
@@ -1536,5 +1532,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - Nov, 2013- Initial Version
    !
    !> @param[in] td_mpp    mpp structure
@@ -1628,4 +1624,8 @@
             IF( il_varid /= 0 )THEN
 
+               CALL logger_error( " MPP ADD VAR: variable "//TRIM(td_var%c_name)//&
+               &  ", standard name "//TRIM(td_var%c_stdname)//&
+               &  ", already in mpp "//TRIM(td_mpp%c_name) )
+
                DO ji=1,td_mpp%t_proc(1)%i_nvar
                   CALL logger_debug( " MPP ADD VAR: in mpp structure : &
@@ -1634,7 +1634,4 @@
                   &  TRIM(td_mpp%t_proc(1)%t_var(ji)%c_stdname) )
                ENDDO
-               CALL logger_error( " MPP ADD VAR: variable "//TRIM(td_var%c_name)//&
-               &  ", standard name "//TRIM(td_var%c_stdname)//&
-               &  ", already in mpp "//TRIM(td_mpp%c_name) )
 
             ELSE
@@ -1678,5 +1675,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_mpp    mpp structure
@@ -1843,6 +1840,4 @@
    !> @author J.Paul
    !> @date November, 2013 - Initial version
-   !> @date February, 2015 
-   !> - define local variable structure to avoid mistake with pointer
    !
    !> @param[inout] td_mpp    mpp strcuture
@@ -1857,5 +1852,4 @@
       ! local variable
       INTEGER(i4)       :: il_varid
-      TYPE(TVAR)        :: tl_var
       !----------------------------------------------------------------
       ! check if mpp exist
@@ -1888,6 +1882,5 @@
             ELSE
 
-               tl_var=var_copy(td_mpp%t_proc(1)%t_var(il_varid))
-               CALL mpp_del_var(td_mpp, tl_var)
+               CALL mpp_del_var(td_mpp, td_mpp%t_proc(1)%t_var(il_varid)) 
 
             ENDIF
@@ -2200,7 +2193,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date July, 2015 
-   !> - rewrite the same as way var_add_dim
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_mpp mpp structure
@@ -2217,33 +2208,51 @@
 
       ! loop indices
+      INTEGER(i4) :: ji
       !----------------------------------------------------------------
       IF( td_mpp%i_ndim <= ip_maxdim )THEN
 
-         ! check if dimension already used in mpp structure
-         il_ind=SCAN(TRIM(cp_dimorder),TRIM(td_dim%c_sname))
-         IF( il_ind == 0 )THEN
-            CALL logger_warn( &
-            &  " MPP ADD DIM: dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", will not be added in mpp "//TRIM(td_mpp%c_name) )
-         ELSEIF( td_mpp%t_dim(il_ind)%l_use )THEN
-            CALL logger_error( &
-            &  " MPP ADD DIM: dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", already used in mpp "//TRIM(td_mpp%c_name) )
+         ! check if dimension already in mpp structure
+         il_ind=dim_get_index(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
+         IF( il_ind /= 0 )THEN
+
+            IF( td_mpp%t_dim(il_ind)%l_use )THEN
+               CALL logger_error( &
+               &  "MPP ADD DIM: dimension "//TRIM(td_dim%c_name)//&
+               &  ", short name "//TRIM(td_dim%c_sname)//&
+               &  ", already used in mpp "//TRIM(td_mpp%c_name) )
+            ELSE
+               ! replace dimension
+               td_mpp%t_dim(il_ind)=dim_copy(td_dim)
+               td_mpp%t_dim(il_ind)%i_id=il_ind
+               td_mpp%t_dim(il_ind)%l_use=.TRUE.
+            ENDIF
+
          ELSE
 
-            ! back to disorder dimension array 
-            CALL dim_disorder(td_mpp%t_dim(:))
-
-            ! add new dimension
-            td_mpp%t_dim(td_mpp%i_ndim+1)=dim_copy(td_dim)
-
-            ! update number of attribute
-            td_mpp%i_ndim=COUNT(td_mpp%t_dim(:)%l_use)
+            IF( td_mpp%i_ndim == ip_maxdim )THEN
+               CALL logger_error( &
+               &  "MPP ADD DIM: can not add dimension "//TRIM(td_dim%c_name)//&
+               &  ", short name "//TRIM(td_dim%c_sname)//&
+               &  ", in mpp "//TRIM(td_mpp%c_name)//". Already "//&
+               &  TRIM(fct_str(ip_maxdim))//" dimensions." )
+            ELSE
+               ! search empty dimension
+               DO ji=1,ip_maxdim
+                  IF( td_mpp%t_dim(ji)%i_id == 0 )THEN
+                     il_ind=ji 
+                     EXIT
+                  ENDIF
+               ENDDO
+ 
+               ! add new dimension    
+               td_mpp%t_dim(il_ind)=dim_copy(td_dim)
+               ! update number of attribute
+               td_mpp%i_ndim=COUNT(td_mpp%t_dim(:)%l_use)
+
+               td_mpp%t_dim(il_ind)%l_use=.TRUE.
+               td_mpp%t_dim(il_ind)%i_id=td_mpp%i_ndim
+            ENDIF
 
          ENDIF
-         ! reorder dimension to ('x','y','z','t')
-         CALL dim_reorder(td_mpp%t_dim(:))
 
       ELSE
@@ -2259,7 +2268,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date July, 2015 
-   !> - rewrite the same as way var_del_dim
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_mpp mpp structure
@@ -2273,34 +2280,55 @@
 
       ! local variable
+      INTEGER(i4) :: il_status
       INTEGER(i4) :: il_ind
-      TYPE(TDIM)  :: tl_dim
+      TYPE(TDIM), DIMENSION(:), ALLOCATABLE  :: tl_dim
 
       ! loop indices
-      !----------------------------------------------------------------
-
-
-      IF( td_mpp%i_ndim <= ip_maxdim )THEN
-
-         CALL logger_trace( &
-         &  " MPP DEL DIM: delete dimension "//TRIM(td_dim%c_name)//&
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! check if dimension already in mpp structure
+      il_ind=dim_get_index(td_mpp%t_dim(:), td_dim%c_name, td_dim%c_sname)
+      IF( il_ind == 0 )THEN
+
+         CALL logger_error( &
+         &  "MPP DEL DIM: no dimension "//TRIM(td_dim%c_name)//&
          &  ", short name "//TRIM(td_dim%c_sname)//&
          &  ", in mpp "//TRIM(td_mpp%c_name) )
-         
-         ! check if dimension already in variable structure
-         il_ind=SCAN(TRIM(cp_dimorder),TRIM(td_dim%c_sname))
-
-         ! replace dimension by empty one
-         td_mpp%t_dim(il_ind)=dim_copy(tl_dim)
-
-         ! update number of dimension
-         td_mpp%i_ndim=COUNT(td_mpp%t_dim(:)%l_use)
-
-         ! reorder dimension to ('x','y','z','t')
-         CALL dim_reorder(td_mpp%t_dim)
 
       ELSE
-         CALL logger_error( &
-         &  " MPP DEL DIM: too much dimension in mpp "//&
-         &  TRIM(td_mpp%c_name)//" ("//TRIM(fct_str(td_mpp%i_ndim))//")")
+
+         ALLOCATE( tl_dim(td_mpp%i_ndim-1), stat=il_status )
+         IF(il_status /= 0 )THEN
+
+            CALL logger_error( &
+            &  "MPP DEL DIM: not enough space to put dimensions from "//&
+            &  TRIM(td_mpp%c_name)//" in temporary dimension structure")
+
+         ELSE
+
+            ! save temporary dimension's mpp structure
+            tl_dim( 1 : il_ind-1 ) = dim_copy(td_mpp%t_dim( 1 : il_ind-1 ))
+            tl_dim( il_ind : td_mpp%i_ndim-1 ) = &
+            &           dim_copy(td_mpp%t_dim( il_ind+1 : td_mpp%i_ndim ))
+
+            ! remove dimension from file
+            CALL dim_clean(td_mpp%t_dim(:))
+            ! copy dimension in file, except one
+            td_mpp%t_dim(1:td_mpp%i_ndim)=dim_copy(tl_dim(:))
+
+            ! update number of dimension
+            td_mpp%i_ndim=td_mpp%i_ndim-1
+
+            ! update dimension id
+            DO ji=1,td_mpp%i_ndim
+               td_mpp%t_dim(ji)%i_id=ji
+            ENDDO
+
+            ! clean
+            CALL dim_clean(tl_dim(:))
+            DEALLOCATE(tl_dim)
+
+         ENDIF
+
       ENDIF
 
@@ -2312,5 +2340,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_mpp mpp structure
@@ -2460,8 +2488,8 @@
             &  ", in mpp structure "//TRIM(td_mpp%c_name) )
 
-            IF( ASSOCIATED(td_mpp%t_proc(1)%t_att) )THEN
+            IF( ASSOCIATED(td_mpp%t_proc(1)%t_var) )THEN
                DO ji=1,td_mpp%t_proc(1)%i_natt
                   CALL logger_debug( "MPP DEL ATT: in mpp structure : &
-                  &  attribute : "//TRIM(td_mpp%t_proc(1)%t_att(ji)%c_name) )
+                  &  attribute : "//TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name) )
                ENDDO
             ENDIF
@@ -2488,6 +2516,4 @@
    !> @author J.Paul
    !> @date November, 2013 - Initial version
-   !> @date February, 2015 
-   !> - define local attribute structure to avoid mistake with pointer
    !
    !> @param[inout] td_mpp    mpp strcuture
@@ -2501,6 +2527,5 @@
 
       ! local variable
-      INTEGER(i4) :: il_attid
-      TYPE(TATT)  :: tl_att
+      INTEGER(i4)       :: il_attid
       !----------------------------------------------------------------
       ! check if mpp exist
@@ -2526,5 +2551,5 @@
             IF( il_attid == 0 )THEN
 
-               CALL logger_debug( &
+               CALL logger_warn( &
                &  "MPP DEL ATT : there is no attribute with "//&
                &  "name "//TRIM(cd_name)//" in mpp structure "//&
@@ -2533,6 +2558,5 @@
             ELSE
 
-               tl_att=att_copy(td_mpp%t_proc(1)%t_att(il_attid))
-               CALL mpp_del_att(td_mpp, tl_att) 
+               CALL mpp_del_att(td_mpp, td_mpp%t_proc(1)%t_att(il_attid)) 
 
             ENDIF
@@ -2839,13 +2863,8 @@
 
             CALL logger_info("MPP OPTIMIZ: number of processor "//&
-            &   TRIM(fct_str(ji))//"x"//TRIM(fct_str(jj))//"="//&
-            &   TRIM(fct_str(tl_mpp%i_nproc)) )
+            &  TRIM(fct_str(tl_mpp%i_nproc)) )
             IF( tl_mpp%i_nproc > td_mpp%i_nproc .AND. &
             &   tl_mpp%i_nproc <= il_maxproc )THEN
                ! save optimiz decomposition 
-
-               CALL logger_info("MPP OPTIMIZ:save this decomposition "//&
-               &   TRIM(fct_str(ji))//"x"//TRIM(fct_str(jj))//"="//&
-               &   TRIM(fct_str(tl_mpp%i_nproc)) )
 
                ! clean mpp
@@ -3127,5 +3146,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> @date November, 2013
    !>
    !> @param[inout] td_mpp mpp strcuture
@@ -3165,5 +3184,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> @date November, 2013
    !>
    !> @param[in] td_mpp    mpp strcuture
@@ -3230,5 +3249,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> @date November, 2013
    !
    !> @param[in] td_mpp    mpp strcuture
@@ -3292,5 +3311,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> @date November, 2013
    !>
    !> @param[inout] td_mpp mpp strcuture
@@ -3385,5 +3404,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[in] td_mpp mpp structure
@@ -3398,4 +3417,5 @@
 
       ! local variable
+      INTEGER(i4) :: il_ndim
 
       ! loop indices
@@ -3409,8 +3429,14 @@
          mpp__check_var_dim=.FALSE.
 
+         CALL logger_error( &
+         &  "MPP CHECK DIM: variable and mpp dimension differ"//&
+         &  " for variable "//TRIM(td_var%c_name)//&
+         &  " and mpp "//TRIM(td_mpp%c_name))
+
          CALL logger_debug( &
          &  " mpp dimension: "//TRIM(fct_str(td_mpp%i_ndim))//&
          &  " variable dimension: "//TRIM(fct_str(td_var%i_ndim)) )
-         DO ji = 1, ip_maxdim
+         il_ndim=MIN(td_var%i_ndim, td_mpp%i_ndim )
+         DO ji = 1, il_ndim
             CALL logger_debug( &
             &  "MPP CHECK DIM: for dimension "//&
@@ -3422,10 +3448,4 @@
             &  ", variable used "//TRIM(fct_str(td_var%t_dim(ji)%l_use)))
          ENDDO
-
-         CALL logger_error( &
-         &  "MPP CHECK DIM: variable and mpp dimension differ"//&
-         &  " for variable "//TRIM(td_var%c_name)//&
-         &  " and mpp "//TRIM(td_mpp%c_name))
-
       ENDIF
 
@@ -3436,5 +3456,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_file   array of file structure
@@ -3476,5 +3496,5 @@
    !
    !> @author J.Paul
-   !> @date Ocotber, 2014 - Initial Version
+   !> - Ocotber, 2014- Initial Version
    !
    !> @param[in] td_mpp   mpp file structure
Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/multi.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/multi.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/multi.f90	(revision 10251)
@@ -61,6 +61,5 @@
 !> @date October, 2014
 !> - use mpp file structure instead of file
-!> @date November, 2014 
-!> - Fix memory leaks bug
+!> @date November, 2014 - Fix memory leaks bug
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -119,5 +118,5 @@
    !>   
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date November, 2014
    !>    - use function instead of overload assignment operator (to avoid memory leak)
@@ -170,7 +169,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date July, 2015 
-   !> - check if variable to be read is in file
+   !> - November, 2013- Initial Version
    !>
    !> @param[in] cd_varfile   variable location information (from namelist) 
@@ -193,5 +190,4 @@
 
       INTEGER(i4)       :: il_nvar
-      INTEGER(i4)       :: il_varid
 
       LOGICAL           :: ll_dim
@@ -246,12 +242,4 @@
                   ! define variable
                   IF( TRIM(fct_lower(cl_lower)) /= 'all' )THEN
-
-                     ! check if variable is in file
-                     il_varid=var_get_index(tl_mpp%t_proc(1)%t_var(:),cl_lower)
-                     IF( il_varid == 0 )THEN
-                        CALL logger_fatal("MULTI INIT: variable "//&
-                           & TRIM(cl_name)//" not in file "//&
-                           & TRIM(cl_file) )
-                     ENDIF
 
                      ! clean var
@@ -329,5 +317,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_multi  multi file structure
@@ -360,5 +348,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_multi multi file structure
@@ -403,5 +391,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date October, 2014
    !> - use mpp file structure instead of file
Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/phycst.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/phycst.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/phycst.f90	(revision 10251)
@@ -25,5 +25,4 @@
    PUBLIC :: dp_rearth  !< earth radius (km)
    PUBLIC :: dp_deg2rad !< degree to radian ratio 
-   PUBLIC :: dp_rad2deg !< radian to degree ratio 
    PUBLIC :: dp_delta   !<  
 
@@ -32,7 +31,6 @@
    REAL(dp), PARAMETER :: dp_rearth = 6871._dp
    REAL(dp), PARAMETER :: dp_deg2rad = dp_pi/180.0
-   REAL(dp), PARAMETER :: dp_rad2deg = 180.0/dp_pi
 
-   REAL(dp), PARAMETER :: dp_delta=1.e-6
+   REAL(dp), PARAMETER :: dp_delta=1.e-2
 END MODULE phycst
 
